module WebServer
    use http, only : response_type, request
    implicit none
    type(response_type) :: response

    private

    public :: get_progress
    contains


    ! https://github.com/modern-fortran/tcp-client-server/blob/master/server.f90


        subroutine get_progress
            ! Send a GET request to retrieve JSON data
            response = request(url='https://proxy.rbwr.dk/progress')

            ! Check if the request was successful
            if (.not. response%ok) then
                print *, 'Error message:', response%err_msg
            else
                ! Print the response details
                print *, 'Response Code    :', response%status_code
                print *, 'Response Length  :', response%content_length
                print *, 'Response Method  :', response%method
                print *, 'Response Content :', response%content
            end if
        end subroutine get_progress
end module WebServer